using System;
using System.Collections.Generic;

namespace Sedici.Hardware
{
    public abstract class JASPmemoryComponent
    {
        private ushort baseAddress;
        private bool installed = true;

        public JASPmemoryComponent(ushort value)
        {
            baseAddress = value;
            HardReset();
            return;
        }

        public JASPmemoryComponent()
        {
            baseAddress = 0;
            HardReset();
            return;
        }

        public bool Installed
        {
            get
            {
                return (installed);
            }
            set
            {
                installed = value;
            }
        }

        public ushort BaseAddress
        {
            get
            {
                return (baseAddress);
            }
            set
            {
                baseAddress = value;
            }
        }

        public bool Contains(ushort address)
        {
            bool contains = false;

            if ((Installed) &&(address >= BaseAddress) && (address < (BaseAddress + Size)))
            {
                contains = true;
            }
            return (contains);
        }

        public abstract ushort Size
        {
            get;
        }

        public abstract ushort Read(ushort address);

        public abstract void Write(ushort address, ushort value);

        public abstract void SoftReset();

        public abstract void HardReset();

    }       
}